﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Sample145862;
using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System.Collections;
using Syncfusion.JavaScript;
using Syncfusion.Linq;
using System.Web.Script.Serialization;
using System.Net;
namespace Sample145862.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
       // List<ParentItem> parent = new List<ParentItem>();

        public ActionResult GridFeatures()
        {

            return View();
        }

        public ActionResult DataSource(DataManager dm)
        {
            IEnumerable DataSource = OrderRepository.GetAllRecords();
            DataResult result = new DataResult();
            DataOperations operation = new DataOperations();
            result.result = DataSource;
            result.count = result.result.AsQueryable().Count();
            if (dm.Skip > 0)
                result.result = operation.PerformSkip(result.result, dm.Skip);
            if (dm.Take > 0)
                result.result = operation.PerformTake(result.result, dm.Take);
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }
        public ActionResult Insert(EditableOrder value)
        {
            if (!ModelState.IsValid) //if validation got failed
            {
                var message = string.Join(" | ", ModelState.Values
                .SelectMany(v => v.Errors)
               .Select(e => e.ErrorMessage));
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest, message);//message returns the exception content 
            }
            OrderRepository.Add(value);
            return Json(value, JsonRequestBehavior.AllowGet); 
        }

        public ActionResult Update(EditableOrder value)
        {
            HttpContext.Response.AddHeader("Exception", "Our Exception message");//add exception message to the response header
            Response.StatusCode = 404; 
            if (value.OrderID > 300) // check some condition and process update action 
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest, "Data is not valid"); //message returns the exception content 
            return Json(value, JsonRequestBehavior.AllowGet); 
        }
        // [HttpPost]
        //public ActionResult CellEditDelete(int key)
        //{
            
        //   throw new Exception("Don't do this again");
           
        //}

     }
}
